// Задача "Water"
// 7-ая личная Интернет-олимпиада сезон 2008/2009
// Автор задачи: Сергей Поромов, poromov@rain.ifmo.ru
// Автор решения: Маским Носенко, nosenkomax@gmail.com
// Короткий тип данных =)

import java.util.*;
import java.io.*;

public class water_mn_wrong2 implements Runnable {

	public static void main(String args[]) {
		new Thread(new water_mn_wrong2()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	private String FNAME = "water";
	boolean eof = false;

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			br.close();
			out.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (IOException e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	short nextShort() {
		return Short.parseShort(nextToken());
	}

	void My_Assert(boolean b, String s) {
		if (!b)
			throw new Error("Assertion " + s);
	}

	final int MAXN = 100000, MAX = 1000000000;

	private void solve() {
		short n = nextShort(), k = nextShort();

		My_Assert(n > 0 && n <= MAXN, "n is out of range: " + n);
		My_Assert(k > 0 && k <= MAX, "k is out of range: " + k);

		short a[] = new short[n];
		for (short i = 0; i < a.length; i++) {
			a[i] = nextShort();
			My_Assert(a[i] > 0 && a[i] <= MAX, "number " + (i + 1)
					+ " is out of range: " + a[i]);
		}

		Arrays.sort(a);
		if (a[n - 1] > k) {
			out.println("Impossible");
			return;
		}

		short ans = 0;

		short left = 0, right = (short) (n - 1);
		while (left <= right) {
			ans++;
			if (a[right] + a[left] <= k) {
				left++;
			}
			right--;
		}
		
		out.println(ans);

	}

	
}